package eu.glorya.math.diplomka.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import eu.glorya.math.diplomka.FactorTrees;
import eu.glorya.math.diplomka.gui.util.LookNFeel;
import eu.glorya.math.diplomka.model.ModelFactory;
import eu.glorya.math.diplomka.model.Word;

public class MenuBar extends JMenuBar {
	private static final long serialVersionUID = -8241745050526630397L;
    
    private static MenuBar instance = null;
    
    private Map<String, JMenuItem> runMenu = new HashMap<String, JMenuItem>();

	public MenuBar() {
        instance = this;
		JMenu menu;
		JMenuItem mi;
		menu = new JMenu(FactorTrees.getMessage("menu.File"));

		mi = new JMenuItem(FactorTrees.getMessage("menu.Exit"), LookNFeel.exitIcon);
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				 System.exit(0);
			}
		});
		menu.add(mi);
		
		add(menu);
		menu = new JMenu(FactorTrees.getMessage("menu.Edit"));

		mi = new JMenuItem(FactorTrees.getMessage("menu.WordConfig"), LookNFeel.wordConfigIcon);
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				 new WordConfigDialogue(FactorTrees.getInstance());
			}
		});
		menu.add(mi);
        runMenu.put("WordConfig", mi);
        
        mi = new JMenuItem(FactorTrees.getMessage("menu.GenerateWord"), LookNFeel.generateWordIcon);
        mi.setEnabled(false);
        mi.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                Word word = ModelFactory.getWord();
                word.buildWord();
                runMenu.get("GenerateWord").setEnabled(false);
                runMenu.get("FindLeftSpecialFactors").setEnabled(true);
                runMenu.get("FindRightSpecialFactors").setEnabled(true);
            }
        });
        menu.add(mi);
        runMenu.put("GenerateWord", mi);
        
        mi = new JMenuItem(FactorTrees.getMessage("menu.FindLeftSpecialFactors"), LookNFeel.leftSpecialsIcon);
        mi.setEnabled(false);
        mi.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                new LeftSpecialFactorsDialogue(FactorTrees.getInstance());
            }
        });
        menu.add(mi);
        runMenu.put("FindLeftSpecialFactors", mi);
        
        mi = new JMenuItem(FactorTrees.getMessage("menu.FindRightSpecialFactors"), LookNFeel.rightSpecialsIcon);
        mi.setEnabled(false);
        mi.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                new RightSpecialFactorsDialogue(FactorTrees.getInstance());
            }
        });
        menu.add(mi);
        runMenu.put("FindRightSpecialFactors", mi);
        
        add(menu);
	}
    
    public static MenuBar getInstance() {
        if(instance == null)
            new MenuBar();
        return instance;
    }

    public Map<String, JMenuItem> getRunMenu() {
        return runMenu;
    }
}
