/* 
 * File:	TreeWindow.java
 * Author:	Jiri Hofman
 *
 * (c) Copyright Jiri Hofman 2007
 */

package eu.glorya.math.diplomka.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;

import eu.glorya.math.diplomka.FactorTrees;
import eu.glorya.math.diplomka.gui.util.LookNFeel;
import eu.glorya.math.diplomka.gui.util.TreeView;
import eu.glorya.math.diplomka.model.search.State;

public class TreeWindow extends JFrame {
    private static final long serialVersionUID = -976571155941647865L;
//    private static final Log LOG = LogFactory.getLog(TreeWindow.class);
    
    public static final int UNDEFINED_FACTOR_TREE = 0;
    public static final int LEFT_FACTOR_TREE = 1;
    public static final int RIGHT_FACTOR_TREE = 2;
    

    public TreeWindow(String title, State treeRoot, int treeType, char[] word, Map<Character, String> rules) {
        super(title);
        
        JMenuBar menuBar = new JMenuBar();
        JMenu menu = new JMenu(FactorTrees.getMessage("menu.File"));
		JMenuItem mi;

//		mi = new JMenuItem(FactorTrees.getMessage("menu.SaveTree"), LookNFeel.saveIcon);
//		mi.addActionListener(new SaveListener(treeRoot));
//		menu.add(mi);
//		
		mi = new JMenuItem(FactorTrees.getMessage("menu.Close"), LookNFeel.exitIcon);
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				 TreeWindow.this.dispose();
			}
		});
		menu.add(mi);
		
		menuBar.add(menu);
        add(menuBar, BorderLayout.NORTH);
		
        TreeView content = new TreeView(this, treeRoot, treeType, word, rules);
        JScrollPane scrollArea = new JScrollPane(content);
        scrollArea.getVerticalScrollBar().setUnitIncrement(30);
        add(scrollArea, BorderLayout.CENTER);
        setSize(500, 500);
        
        setVisible(true);
    }
}
