package eu.glorya.math.diplomka.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import eu.glorya.math.diplomka.FactorTrees;
import eu.glorya.math.diplomka.model.ModelFactory;
import eu.glorya.math.diplomka.model.WordConfig;

public class WordConfigDialogue extends JDialog {
	private static final long serialVersionUID = 5744784978085930358L;
	private static final Log LOG = LogFactory.getLog(WordConfigDialogue.class);

    JTextField rules;
    JTextField startLetter;
    JTextField wordLength;
    
	public WordConfigDialogue(JFrame owner) {
		super(owner, FactorTrees.getMessage("menu.WordConfig"));
		setModal(true);
		
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(4, 2));
		
        WordConfig wordConfig = ModelFactory.getWordConfig();
        
		panel.add(new JLabel(FactorTrees.getMessage("wordConfig.EnterCommaseparatedRules")));
        
		rules = new JTextField(wordConfig.getRulesString(), 30);
		panel.add(rules);
        
		panel.add(new JLabel(FactorTrees.getMessage("wordConfig.EnterStartLetter")));
        
        startLetter = new JTextField(wordConfig.getStartLetter().toString(), 1);
        panel.add(startLetter);
        
        panel.add(new JLabel(FactorTrees.getMessage("wordConfig.EnterWordLength")));
        wordLength = new JTextField(wordConfig.getWordLength().toString(), 1);
        panel.add(wordLength);
        
		JButton ok = new JButton(FactorTrees.getMessage("button.OK"));
        ok.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                WordConfig wordConfig = ModelFactory.getWordConfig();
                Map<String, JMenuItem> menu = MenuBar.getInstance().getRunMenu();
                try {
                    wordConfig.setRulesString(rules.getText());
                    wordConfig.setStartLetter(startLetter.getText().charAt(0));
                    int wordLen = Integer.parseInt(wordLength.getText());
                    wordConfig.setWordLength(wordLen);
                    menu.get("GenerateWord").setEnabled(true);
                    WordConfigDialogue.this.dispose();
                } catch(Exception ex) {
                    menu.get("GenerateWord").setEnabled(false);
                	JOptionPane.showMessageDialog(WordConfigDialogue.this, ex.getMessage(), FactorTrees.getMessage("exception.Error"), JOptionPane.ERROR_MESSAGE);
//                    ex.printStackTrace();
                } finally {
                    menu.get("FindLeftSpecialFactors").setEnabled(false);
                    menu.get("FindRightSpecialFactors").setEnabled(false);
                }
            }
        });
        panel.add(ok);
        
        JButton cancel = new JButton(FactorTrees.getMessage("button.Cancel"));
        cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                WordConfigDialogue.this.dispose();
            }
        });
        panel.add(cancel);
        
		add(panel, BorderLayout.CENTER);
		Dimension d = panel.getPreferredSize();
		LOG.debug("Trying to set dialogue window dimensions: " + d);
		d.height += 30;
		setSize(d);
		setResizable(false);
		setModal(true);
		setVisible(true);
	}
}
