/* 
 * File:	SaveListener.java
 * Author:	Jiri Hofman
 * Created:	20.8.2006
 *
 * (c) Copyright Jiri Hofman 2006
 */

package eu.glorya.math.diplomka.gui.util;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;

import eu.glorya.math.diplomka.FactorTrees;
import eu.glorya.math.diplomka.model.search.State;


public class SaveListener implements ActionListener {
	private static final Log LOG = LogFactory.getLog(SaveListener.class);
	private State root;

    public SaveListener(State root) {
        this.root = root;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
    	LOG.debug("Special factor tree saving requested");
        JFileChooser fileChooser = new JFileChooser(new File("."));
        fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        fileChooser.setMultiSelectionEnabled(false);
        fileChooser.setFileFilter(new FileFilter() {
            @Override
            public String getDescription() {
                return FactorTrees.getMessage("file.FileTypeDescription");
            }

            @Override
            public boolean accept(File f) {
                return f.getName().endsWith("xml") || f.getName().endsWith("XML") || f.isDirectory();
            }
        });
        if(fileChooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
            try {
            	File f = fileChooser.getSelectedFile();
                BufferedWriter w = new BufferedWriter(new FileWriter(f));
                Document doc = DocumentHelper.createDocument();
//                w.write();
                w.flush();
                w.close();
            } catch(IOException e1) {
                JOptionPane.showMessageDialog(null, "Error while saving file:\n" + e1.getMessage(), "Error while saving file", JOptionPane.ERROR_MESSAGE);
            }
        }
    }
}
