/* 
 * File:	LimitedIndexList.java
 * Author:	Jiri Hofman
 *
 * (c) Copyright Jiri Hofman 2007
 */

package eu.glorya.math.diplomka.model;

public class LimitedIndexList {
    private int allocated = 16;
    private int position = 0;
    private int limit = 1024;
    private int[] indices = new int[10];
    
    public void add(int index) {
        if(position == allocated) {
            if(position >= limit)
                return;
            int[] swap = indices;
            indices = new int[2*allocated];
            for(int i=0; i<allocated; i++) {
                indices[i] = swap[i];
            }
            allocated *= 2;
            swap = null;
        }
        indices[position++] = index;
    }
    
    public int getSize() {
        return position;
    }
    
    public int[] getIndices() {
        return indices;
    }
}
