/* 
 * File:	Word.java
 * Author:	Jiri Hofman
 *
 * (c) Copyright Jiri Hofman 2006
 */

package eu.glorya.math.diplomka.model;

import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class Word {
    private static final Log LOG = LogFactory.getLog(Word.class);
    
    private char[] word = null;
    private int length;
    
    public void buildWord() {
        WordConfig wordConfig = ModelFactory.getWordConfig();
        
        if(word != null) {
            LOG.info("Invoking garbage collector");
            word = null;
            System.gc();
        }
        
        length = wordConfig.getWordLength();
        Map<Character, String> morphism = wordConfig.getMorphism();
        
        int currentLength = 0;
        int runtimeSubstitutionIndex = 0;
        word = new char[length];
        word[0] = wordConfig.getStartLetter();
        while(currentLength < length) {
            for(char n : morphism.get(word[runtimeSubstitutionIndex]).toCharArray()) {
                word[currentLength] = n;
                currentLength++;
                if(currentLength == length) {
                    break;
                }
            }
            runtimeSubstitutionIndex++;
//            if(LOG.isDebugEnabled()) {
//                String out = "";
//                for(int i=0; i<currentLength; i++)
//                    out += word[i];
//                LOG.debug("Generated: " + out);
//            }
        }
        LOG.info("Generated word length: " + word.length);
//        LOG.debug("Word: " + new String(word));
    }
    
    public boolean isWordBuilt() {
        return word != null;
    }
    
    public char[] getWord() {
        return word;
    }
}
